7311: Make recognizable temp dirs under a single base; allow override with --temp DIR
[arvados-dev.git] / jenkins / run-tests.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
4
5 read -rd "\000" helpmessage <<EOF
6 $(basename $0): Install and test Arvados components.
7
8 Exit non-zero if any tests fail.
9
10 Syntax:
11         $(basename $0) WORKSPACE=/path/to/arvados [options]
12
13 Options:
14
15 --skip FOO     Do not test the FOO component.
16 --only FOO     Do not test anything except the FOO component.
17 --temp DIR     Install components and dependencies under DIR instead of
18                making a new temporary directory. Implies --leave-temp.
19 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
20                Instead, show the path to give as --temp to reuse them in
21                subsequent invocations.
22 --skip-install Do not run any install steps. Just run tests.
23                You should provide GOPATH, GEMHOME, and VENVDIR options
24                from a previous invocation if you use this option.
25 --only-install Run specific install step
26 WORKSPACE=path Arvados source tree to test.
27 CONFIGSRC=path Dir with api server config files to copy into source tree.
28                (If none given, leave config files alone in source tree.)
29 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
30                Restrict apiserver tests to the given file
31 sdk/python_test="--test-suite test.test_keep_locator"
32                Restrict Python SDK tests to the given class
33 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
34                Restrict Workbench tests to the given file
35 services/arv-git-httpd_test="-check.vv"
36                Show all log messages, even when tests pass (also works
37                with services/keepstore_test etc.)
38 ARVADOS_DEBUG=1
39                Print more debug messages
40 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
41                *_test, and other examples shown above.
42
43 Assuming --skip-install is not given, all components are installed
44 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
45 test suites depend on other components being installed, and installing
46 everything tends to be quicker than debugging dependencies.
47
48 As a special concession to the current CI server config, CONFIGSRC
49 defaults to $HOME/arvados-api-server if that directory exists.
50
51 More information and background:
52
53 https://arvados.org/projects/arvados/wiki/Running_tests
54
55 Available tests:
56
57 apps/workbench
58 apps/workbench_benchmark
59 apps/workbench_profile
60 doc
61 services/api
62 services/crunchstat
63 services/dockercleaner
64 services/fuse
65 services/keepproxy
66 services/keepstore
67 services/login-sync
68 services/nodemanager
69 services/arv-git-httpd
70 sdk/cli
71 sdk/pam
72 sdk/python
73 sdk/ruby
74 sdk/go/arvadosclient
75 sdk/go/keepclient
76 sdk/go/streamer
77
78 EOF
79
80 # First make sure to remove any ARVADOS_ variables from the calling
81 # environment that could interfere with the tests.
82 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
83
84 # Reset other variables that could affect our [tests'] behavior by
85 # accident.
86 GITDIR=
87 GOPATH=
88 VENVDIR=
89 VENV3DIR=
90 PYTHONPATH=
91 GEMHOME=
92 PERLINSTALLBASE=
93
94 COLUMNS=80
95
96 skip_install=
97 temp=
98 temp_preserve=
99
100 clear_temp() {
101     if [[ -z "$temp" ]]; then
102         # we didn't even get as far as making a temp dir
103         :
104     elif [[ -z "$temp_preserve" ]]; then
105         rm -rf "$temp"
106     else
107         echo "Leaving behind temp dirs in $temp"
108     fi
109 }
110
111 fatal() {
112     clear_temp
113     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
114     exit 1
115 }
116
117 report_outcomes() {
118     for x in "${successes[@]}"
119     do
120         echo "Pass: $x"
121     done
122
123     if [[ ${#failures[@]} == 0 ]]
124     then
125         echo "All test suites passed."
126     else
127         echo "Failures (${#failures[@]}):"
128         for x in "${failures[@]}"
129         do
130             echo "Fail: $x"
131         done
132     fi
133 }
134
135 exit_cleanly() {
136     trap - INT
137     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
138     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
139     stop_services
140     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
141     report_outcomes
142     clear_temp
143     exit ${#failures}
144 }
145
146 sanity_checks() {
147     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
148         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
149     echo Checking dependencies:
150     echo -n 'virtualenv: '
151     virtualenv --version \
152         || fatal "No virtualenv. Try: apt-get install virtualenv"
153     echo -n 'go: '
154     go version \
155         || fatal "No go binary. See http://golang.org/doc/install"
156     echo -n 'gcc: '
157     gcc --version | egrep ^gcc \
158         || fatal "No gcc. Try: apt-get install build-essential"
159     echo -n 'fuse.h: '
160     find /usr/include -wholename '*fuse/fuse.h' \
161         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
162     echo -n 'pyconfig.h: '
163     find /usr/include -name pyconfig.h | egrep --max-count=1 . \
164         || fatal "No pyconfig.h. Try: apt-get install python-dev"
165     echo -n 'nginx: '
166     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
167         || fatal "No nginx. Try: apt-get install nginx"
168     echo -n 'perl: '
169     perl -v | grep version \
170         || fatal "No perl. Try: apt-get install perl"
171     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
172         echo -n "perl $mod: "
173         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
174             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl"
175     done
176     echo -n 'gitolite: '
177     which gitolite \
178         || fatal "No gitolite. Try: apt-get install gitolite3"
179 }
180
181 rotate_logfile() {
182   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
183   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
184   if [[ -f "$1/$2" ]]; then
185     THEDATE=`date +%Y%m%d%H%M%S`
186     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
187     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
188   fi
189 }
190
191 declare -a failures
192 declare -A skip
193 declare -A testargs
194 skip[apps/workbench_profile]=1
195
196 while [[ -n "$1" ]]
197 do
198     arg="$1"; shift
199     case "$arg" in
200         --help)
201             echo >&2 "$helpmessage"
202             echo >&2
203             exit 1
204             ;;
205         --skip)
206             skipwhat="$1"; shift
207             skip[$skipwhat]=1
208             ;;
209         --only)
210             only="$1"; skip[$1]=""; shift
211             ;;
212         --skip-install)
213             skip_install=1
214             ;;
215         --only-install)
216             skip_install=1
217             only_install="$1"; shift
218             ;;
219         --temp)
220             temp="$1"; shift
221             temp_preserve=1
222             ;;
223         --leave-temp)
224             temp_preserve=1
225             ;;
226         --retry)
227             retry=1
228             ;;
229         *_test=*)
230             suite="${arg%%_test=*}"
231             args="${arg#*=}"
232             testargs["$suite"]="$args"
233             ;;
234         *=*)
235             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
236             ;;
237         *)
238             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
239             exit 1
240             ;;
241     esac
242 done
243
244 start_api() {
245     echo 'Starting API server...'
246     cd "$WORKSPACE" \
247         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
248         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
249         && export ARVADOS_TEST_API_INSTALLED="$$" \
250         && (env | egrep ^ARVADOS)
251 }
252
253 start_nginx_proxy_services() {
254     echo 'Starting keepproxy, arv-git-httpd, and nginx ssl proxy...'
255     cd "$WORKSPACE" \
256         && python sdk/python/tests/run_test_server.py start_keep_proxy \
257         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
258         && python sdk/python/tests/run_test_server.py start_nginx \
259         && export ARVADOS_TEST_PROXY_SERVICES=1
260 }
261
262 stop_services() {
263     if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
264         unset ARVADOS_TEST_PROXY_SERVICES
265         cd "$WORKSPACE" \
266             && python sdk/python/tests/run_test_server.py stop_nginx \
267             && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
268             && python sdk/python/tests/run_test_server.py stop_keep_proxy
269     fi
270     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
271         unset ARVADOS_TEST_API_HOST
272         cd "$WORKSPACE" \
273             && python sdk/python/tests/run_test_server.py stop
274     fi
275 }
276
277 interrupt() {
278     failures+=("($(basename $0) interrupted)")
279     exit_cleanly
280 }
281 trap interrupt INT
282
283 sanity_checks
284
285 echo "WORKSPACE=$WORKSPACE"
286
287 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
288     # Jenkins expects us to use this by default.
289     CONFIGSRC="$HOME/arvados-api-server"
290 fi
291
292 # Clean up .pyc files that may exist in the workspace
293 cd "$WORKSPACE"
294 find -name '*.pyc' -delete
295
296 if [[ -z "$temp" ]]; then
297     temp="$(mktemp -d)"
298 fi
299
300 # Set up temporary install dirs (unless existing dirs were supplied)
301 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
302 do
303     if [[ -n "${!tmpdir}" ]]; then
304         # Support old user-named temp dirs (but --temp {base} would
305         # be more convenient)
306         mkdir -p "${!tmpdir}"
307     else
308         eval "$tmpdir"="$temp/$tmpdir"
309     fi
310 done
311
312 setup_ruby_environment() {
313     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
314       source "$HOME/.rvm/scripts/rvm"
315       using_rvm=true
316     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
317       source "/usr/local/rvm/scripts/rvm"
318       using_rvm=true
319     else
320       using_rvm=false
321     fi
322
323     if [[ "$using_rvm" == true ]]; then
324         # If rvm is in use, we can't just put separate "dependencies"
325         # and "gems-under-test" paths to GEM_PATH: passenger resets
326         # the environment to the "current gemset", which would lose
327         # our GEM_PATH and prevent our test suites from running ruby
328         # programs (for example, the Workbench test suite could not
329         # boot an API server or run arv). Instead, we have to make an
330         # rvm gemset and use it for everything.
331
332         [[ `type rvm | head -n1` == "rvm is a function" ]] \
333             || fatal 'rvm check'
334
335         # Put rvm's favorite path back in first place (overriding
336         # virtualenv, which just put itself there). Ignore rvm's
337         # complaint about not being in first place already.
338         rvm use @default 2>/dev/null
339
340         # Create (if needed) and switch to an @arvados-tests
341         # gemset. (Leave the choice of ruby to the caller.)
342         rvm use @arvados-tests --create \
343             || fatal 'rvm gemset setup'
344
345         rvm env
346     else
347         # When our "bundle install"s need to install new gems to
348         # satisfy dependencies, we want them to go where "gem install
349         # --user-install" would put them. (However, if the caller has
350         # already set GEM_HOME, we assume that's where dependencies
351         # should be installed, and we should leave it alone.)
352
353         if [ -z "$GEM_HOME" ]; then
354             user_gempath="$(gem env gempath)"
355             export GEM_HOME="${user_gempath%%:*}"
356         fi
357         PATH="$(gem env gemdir)/bin:$PATH"
358
359         # When we build and install our own gems, we install them in our
360         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
361         # PATH so integration tests prefer them over other versions that
362         # happen to be installed in $user_gempath, system dirs, etc.
363
364         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
365         PATH="$tmpdir_gem_home/bin:$PATH"
366         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
367
368         echo "Will install dependencies to $(gem env gemdir)"
369         echo "Will install arvados gems to $tmpdir_gem_home"
370         echo "Gem search path is GEM_PATH=$GEM_PATH"
371     fi
372 }
373
374 with_test_gemset() {
375     if [[ "$using_rvm" == true ]]; then
376         "$@"
377     else
378         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
379     fi
380 }
381
382 gem_uninstall_if_exists() {
383     if gem list "$1\$" | egrep '^\w'; then
384         gem uninstall --force --all --executables "$1"
385     fi
386 }
387
388 export PERLINSTALLBASE
389 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
390
391 export GOPATH
392 mkdir -p "$GOPATH/src/git.curoverse.com"
393 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
394     || fatal "symlink failed"
395
396 if ! [[ -e "$VENVDIR/bin/activate" ]] || ! [[ -e "$VENVDIR/bin/pip" ]]; then
397     virtualenv --setuptools "$VENVDIR" || fatal "virtualenv $VENVDIR failed"
398 fi
399 . "$VENVDIR/bin/activate"
400
401 if (pip install setuptools | grep setuptools-0) || [ "$($VENVDIR/bin/easy_install --version | cut -d\  -f2 | cut -d. -f1)" -lt 18 ]; then
402     pip install --upgrade setuptools pip
403 fi
404
405 # Note: this must be the last time we change PATH, otherwise rvm will
406 # whine a lot.
407 setup_ruby_environment
408
409 echo "PATH is $PATH"
410
411 if ! which bundler >/dev/null
412 then
413     gem install --user-install bundler || fatal 'Could not install bundler'
414 fi
415
416 # Needed for run_test_server.py which is used by certain (non-Python) tests.
417 pip freeze 2>/dev/null | egrep ^PyYAML= \
418     || pip install PyYAML >/dev/null \
419     || fatal "pip install PyYAML failed"
420
421 # Preinstall forked version of libcloud, because nodemanager "pip install"
422 # won't pick it up by default.
423 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
424     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
425     || fatal "pip install apache-libcloud failed"
426
427 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
428 # Otherwise, skip dependent tests.
429 PYTHON3=$(which python3)
430 if [ "0" = "$?" ]; then
431     virtualenv --python "$PYTHON3" --setuptools "$VENV3DIR" \
432         || fatal "python3 virtualenv $VENV3DIR failed"
433 else
434     PYTHON3=
435     skip[services/dockercleaner]=1
436     cat >&2 <<EOF
437
438 Warning: python3 could not be found
439 services/dockercleaner install and tests will be skipped
440
441 EOF
442 fi
443
444 checkexit() {
445     if [[ "$1" != "0" ]]; then
446         title "!!!!!! $2 FAILED !!!!!!"
447         failures+=("$2 (`timer`)")
448     else
449         successes+=("$2 (`timer`)")
450     fi
451 }
452
453 timer_reset() {
454     t0=$SECONDS
455 }
456
457 timer() {
458     echo -n "$(($SECONDS - $t0))s"
459 }
460
461 do_test() {
462     while ! do_test_once ${@} && [[ "$retry" == 1 ]]
463     do
464         read -p 'Try again? [Y/n] ' x
465         if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
466         then
467             break
468         fi
469     done
470 }
471
472 do_test_once() {
473     unset result
474     if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
475     then
476         title "Running $1 tests"
477         timer_reset
478         if [[ "$2" == "go" ]]
479         then
480             covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
481             coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
482             if [[ -n "${testargs[$1]}" ]]
483             then
484                 # "go test -check.vv giturl" doesn't work, but this
485                 # does:
486                 cd "$WORKSPACE/$1" && go test ${coverflags[@]} ${testargs[$1]}
487             else
488                 # The above form gets verbose even when testargs is
489                 # empty, so use this form in such cases:
490                 go test ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
491             fi
492             result="$?"
493             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
494             rm "$WORKSPACE/tmp/.$covername.tmp"
495         elif [[ "$2" == "pip" ]]
496         then
497             # $3 can name a path directory for us to use, including trailing
498             # slash; e.g., the bin/ subdirectory of a virtualenv.
499             cd "$WORKSPACE/$1" \
500                 && "${3}python" setup.py test ${testargs[$1]}
501         elif [[ "$2" != "" ]]
502         then
503             "test_$2"
504         else
505             "test_$1"
506         fi
507         result=${result:-$?}
508         checkexit $result "$1 tests"
509         title "End of $1 tests (`timer`)"
510         return $result
511     else
512         title "Skipping $1 tests"
513     fi
514 }
515
516 do_install() {
517     if [[ -z "$skip_install" || (-n "$only_install" && "$only_install" == "$1") ]]
518     then
519         title "Running $1 install"
520         timer_reset
521         if [[ "$2" == "go" ]]
522         then
523             go get -t "git.curoverse.com/arvados.git/$1"
524         elif [[ "$2" == "pip" ]]
525         then
526             # $3 can name a path directory for us to use, including trailing
527             # slash; e.g., the bin/ subdirectory of a virtualenv.
528
529             # Need to change to a different directory after creating
530             # the source dist package to avoid a pip bug.
531             # see https://arvados.org/issues/5766 for details.
532
533             # Also need to install twice, because if it believes the package is
534             # already installed, pip it won't install it.  So the first "pip
535             # install" ensures that the dependencies are met, the second "pip
536             # install" ensures that we've actually installed the local package
537             # we just built.
538             cd "$WORKSPACE/$1" \
539                 && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
540                 && cd "$WORKSPACE" \
541                 && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
542                 && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
543         elif [[ "$2" != "" ]]
544         then
545             "install_$2"
546         else
547             "install_$1"
548         fi
549         checkexit $? "$1 install"
550         title "End of $1 install (`timer`)"
551     else
552         title "Skipping $1 install"
553     fi
554 }
555
556 title () {
557     txt="********** $1 **********"
558     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
559 }
560
561 bundle_install_trylocal() {
562     (
563         set -e
564         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
565         if ! bundle install --local --no-deployment; then
566             echo "(Running bundle install again, without --local.)"
567             bundle install --no-deployment
568         fi
569         bundle package --all
570     )
571 }
572
573 install_doc() {
574     cd "$WORKSPACE/doc" \
575         && bundle_install_trylocal \
576         && rm -rf .site
577 }
578 do_install doc
579
580 install_gem() {
581     gemname=$1
582     srcpath=$2
583     with_test_gemset gem_uninstall_if_exists "$gemname" \
584         && cd "$WORKSPACE/$srcpath" \
585         && bundle_install_trylocal \
586         && gem build "$gemname.gemspec" \
587         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
588 }
589
590 install_ruby_sdk() {
591     install_gem arvados sdk/ruby
592 }
593 do_install sdk/ruby ruby_sdk
594
595 install_perl_sdk() {
596     cd "$WORKSPACE/sdk/perl" \
597         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
598         && make install INSTALLDIRS=perl
599 }
600 do_install sdk/perl perl_sdk
601
602 install_cli() {
603     install_gem arvados-cli sdk/cli
604 }
605 do_install sdk/cli cli
606
607 install_login-sync() {
608     install_gem arvados-login-sync services/login-sync
609 }
610 do_install services/login-sync login-sync
611
612 # Install the Python SDK early. Various other test suites (like
613 # keepproxy) bring up run_test_server.py, which imports the arvados
614 # module. We can't actually *test* the Python SDK yet though, because
615 # its own test suite brings up some of those other programs (like
616 # keepproxy).
617 declare -a pythonstuff
618 pythonstuff=(
619     sdk/pam
620     sdk/python
621     services/fuse
622     services/nodemanager
623     )
624 for p in "${pythonstuff[@]}"
625 do
626     do_install "$p" pip
627 done
628 if [ -n "$PYTHON3" ]; then
629     do_install services/dockercleaner pip "$VENV3DIR/bin/"
630 fi
631
632 install_apiserver() {
633     cd "$WORKSPACE/services/api" \
634         && RAILS_ENV=test bundle_install_trylocal
635
636     rm -f config/environments/test.rb
637     cp config/environments/test.rb.example config/environments/test.rb
638
639     if [ -n "$CONFIGSRC" ]
640     then
641         for f in database.yml application.yml
642         do
643             cp "$CONFIGSRC/$f" config/ || fatal "$f"
644         done
645     fi
646
647     # Fill in a random secret_token and blob_signing_key for testing
648     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
649     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
650
651     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
652     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
653
654     # Set up empty git repo (for git tests)
655     GITDIR=$(mktemp -d)
656     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
657
658     rm -rf $GITDIR
659     mkdir -p $GITDIR/test
660     cd $GITDIR/test \
661         && git init \
662         && git config user.email "jenkins@ci.curoverse.com" \
663         && git config user.name "Jenkins, CI" \
664         && touch tmp \
665         && git add tmp \
666         && git commit -m 'initial commit'
667
668     # Clear out any lingering postgresql connections to the test
669     # database, so that we can drop it. This assumes the current user
670     # is a postgresql superuser.
671     cd "$WORKSPACE/services/api" \
672         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
673         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
674
675     cd "$WORKSPACE/services/api" \
676         && RAILS_ENV=test bundle exec rake db:drop \
677         && RAILS_ENV=test bundle exec rake db:setup \
678         && RAILS_ENV=test bundle exec rake db:fixtures:load
679 }
680 do_install services/api apiserver
681
682 declare -a gostuff
683 gostuff=(
684     services/arv-git-httpd
685     services/crunchstat
686     services/keepstore
687     services/keepproxy
688     services/datamanager/summary
689     services/datamanager/collection
690     sdk/go/arvadosclient
691     sdk/go/keepclient
692     sdk/go/streamer
693     )
694 for g in "${gostuff[@]}"
695 do
696     do_install "$g" go
697 done
698
699 install_workbench() {
700     cd "$WORKSPACE/apps/workbench" \
701         && mkdir -p tmp/cache \
702         && RAILS_ENV=test bundle_install_trylocal
703 }
704 do_install apps/workbench workbench
705
706 test_doclinkchecker() {
707     (
708         set -e
709         cd "$WORKSPACE/doc"
710         ARVADOS_API_HOST=qr1hi.arvadosapi.com
711         # Make sure python-epydoc is installed or the next line won't
712         # do much good!
713         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
714     )
715 }
716 do_test doc doclinkchecker
717
718 stop_services
719
720 test_apiserver() {
721     cd "$WORKSPACE/services/api" \
722         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
723 }
724 do_test services/api apiserver
725
726 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
727 # because we don't need to start up the api server for subsequent tests.
728 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
729   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
730   exit_cleanly
731 fi
732
733 start_api
734
735 test_ruby_sdk() {
736     cd "$WORKSPACE/sdk/ruby" \
737         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
738 }
739 do_test sdk/ruby ruby_sdk
740
741 test_cli() {
742     cd "$WORKSPACE/sdk/cli" \
743         && mkdir -p /tmp/keep \
744         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
745 }
746 do_test sdk/cli cli
747
748 test_login-sync() {
749     cd "$WORKSPACE/services/login-sync" \
750         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
751 }
752 do_test services/login-sync login-sync
753
754 for p in "${pythonstuff[@]}"
755 do
756     do_test "$p" pip
757 done
758 do_test services/dockercleaner pip "$VENV3DIR/bin/"
759
760 for g in "${gostuff[@]}"
761 do
762     do_test "$g" go
763 done
764
765 test_workbench() {
766     start_nginx_proxy_services \
767         && cd "$WORKSPACE/apps/workbench" \
768         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
769 }
770 do_test apps/workbench workbench
771
772 test_workbench_benchmark() {
773     start_nginx_proxy_services \
774         && cd "$WORKSPACE/apps/workbench" \
775         && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
776 }
777 do_test apps/workbench_benchmark workbench_benchmark
778
779 test_workbench_profile() {
780     start_nginx_proxy_services \
781         && cd "$WORKSPACE/apps/workbench" \
782         && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
783 }
784 do_test apps/workbench_profile workbench_profile
785
786 exit_cleanly